module DictSearchParallel (dict_search) where

import SearchParallel(word_exist_par)
import Data.Array
import Control.Parallel.Strategies
    ( parBuffer, using, rseq )

dict_search :: Array (Int, Int) Char -> Int -> Int -> [String] -> [Bool]
dict_search _ _ _ [] = []
dict_search matrix m n query_words = map (word_exist_par matrix m n) query_words `using` parBuffer 10 rseq
